// ----------------------------------------------------------------------------
//
// FishFace40.PAS                                        Ulrich Mller 21.11.05
//                                                       PCS1700     Delphi4.03
// Basisklassen zur Ansteuerung der fischertechnik Interfaces aus Delphi 4
// Basis : umFish40.DLL - Spezialversion fr ftTeach40
//
// -----------------------------------------------------------------------------

unit FishFace40;

interface
uses
    Windows, Messages, SysUtils, Classes, Forms;
const
//  --- ftiInterfaces ---
    ftiROBO_first_USB       = 0;    ftiIntelligent_IF       = 10;
    ftiIntelligent_IF_Slave = 20;   ftiROBO_IF_IIM          = 50;
    ftiROBO_IF_USB          = 60;   ftiROBO_IF_COM          = 70;
    ftiROBO_IF_Over_RF      = 80;   ftiROBO_IO_Extension    = 90;

//  --- ftiPorts ---
    ftiCOM1 = 1; ftiCOM2 = 2; ftiCOM3 = 3; ftiCOM4 = 4;

//  --- ftiDir ---
    ftiLinks = 1; ftiRechts = 2; ftiLeft = 1; ftiRight = 2;
    ftiAus = 0;   ftiEin = 1;    ftiOff = 0;  ftiOn = 1;

//  --- ftiIRCode ---
    ftiAll = 0;   ftiCode1 = 1; ftiCode2 = 2;

//  --- ftiIRKeys ---
    ftiM3R = 1;   ftiM3L = 2;  ftiM1S = 3;  ftiM2S = 4;  ftiM3S = 5;
    ftiSCode1 = 6; ftiM1BW = 7; ftiM1FW = 8; ftiM2L = 9;  ftiM2R = 10;
    ftiSCode2 = 11;

//  --- ftiInp ---
    ftiEX = 1;   ftiEY = 2;
    ftiAX = 1;   ftiAY = 2;   ftiAXS1 = 3; ftiAXS2 = 4; ftiAXS3 = 5;
    ftiA1 = 1;   ftiA2 = 2;   ftiAV   = 3; ftiAZ   = 4;
    ftiD1 = 1;   ftiD2 = 2;

    ftiE1  = 1;  ftiE2  = 2;  ftiE3  = 3;  ftiE4 = 4;
    ftiE5  = 5;  ftiE6  = 6;  ftiE7  = 7;  ftiE8 = 8;
    ftiE9  = 9;  ftiE10 = 10; ftiE11 = 11; ftiE12 = 12;
    ftiE13 = 13; ftiE14 = 14; ftiE15 = 15; ftiE16 = 16;
    ftiI1  = 1;  ftiI2  = 2;  ftiI3  = 3;  ftiI4 = 4;
    ftiI5  = 5;  ftiI6  = 6;  ftiI7  = 7;  ftiI8 = 8;
    ftiI9  = 9;  ftiI10 = 10; ftiI11 = 11; ftiI12 = 12;
    ftiI13 = 13; ftiI14 = 14; ftiI15 = 15; ftiI16 = 16;
    ftiI17 = 17; ftiI18 = 18; ftiI19 = 19; ftiI20 = 20;
    ftiI21 = 21; ftiI22 = 22; ftiI23 = 23; ftiI24 = 24;
    ftiI25 = 25; ftiI26 = 26; ftiI27 = 27; ftiI28 = 28;
    ftiI29 = 29; ftiI30 = 30; ftiI31 = 31; ftiI32 = 32;

//  --- ftiOut ---
    ftiM1 = 1;   ftiM2 = 2;   ftiM3  = 3;  ftiM4 = 4;
    ftiM5 = 5;   ftiM6 = 6;   ftiM7  = 7;  ftiM8 = 8;
    ftiM9 = 9;   ftiM10 = 10; ftiM11 = 11; ftiM12 = 12;
    ftiM13 = 13; ftiM14 = 14; ftiM15 = 15; ftiM16 = 16;

    ftiO1  = 1;  ftiO2  = 2;  ftiO3  = 3;  ftiO4  = 4;
    ftiO5  = 5;  ftiO6  = 6;  ftiO7  = 7;  ftiO8  = 8;
    ftiO9  = 9;  ftiO10 = 10; ftiO11 = 11; ftiO12 = 12;
    ftiO13 = 13; ftiO14 = 14; ftiO15 = 15; ftiO16 = 16;
    ftiO17 = 17; ftiO18 = 18; ftiO19 = 19; ftiO20 = 20;
    ftiO21 = 21; ftiO22 = 22; ftiO23 = 23; ftiO24 = 24;
    ftiO25 = 25; ftiO26 = 26; ftiO27 = 27; ftiO28 = 28;
    ftiO29 = 29; ftiO30 = 30; ftiO31 = 31; ftiO32 = 32;

//  --- ftiSpeed ---
    ftiNone = 0;  ftiHalf = 4; ftiFull = 7;

//  --- ftiWait ---
    ftiEnde = 0; ftiTime = 1; ftiNotHalt = 2; ftiESC = 3;

    nullPos = 999;

type
    DeviceData = record
      Name     : String;
      Typ      : LongInt;
      SerialNr : LongInt;
      Firmware : String;
    end;
    PosSatz = record
      maxPosition: LongInt;
      aktPosition: LongInt;
    end;

  FishFaceException = class(Exception);
  TFishRobot = class;
  TFishPosition = procedure(Sender: TFishRobot; Pos1, Pos2,
                                                Pos3, Pos4: LongInt) of object;

// ------------------------ TFishFace --------------------------------------

TFishFace = class(TObject)

private
  iHandle:       LongInt;           // --- Handle zur umFish40.DLL Instanz
  FVersion:      string;            // --- Version der Unit
  FNotHalt:      Boolean;           // --- Nothalt
  FOpen:         Boolean;           // --- Open-Merker
  FDoEvents:     Boolean;           // --- mit/ohne Applicaton.ProcessMessages

  function       GetOutputs: LongInt;
  function       GetStatus: Boolean;
  function       GetActDevice: DeviceData;

public
  property ActDevice:    DeviceData read GetActDevice;
  property NotHalt:      Boolean read FNotHalt write FNotHalt;
  property Outputs:      LongInt read GetOutputs;
  property Status:       Boolean read GetStatus;
  property Version:      string  read FVersion;

  procedure ClearCounter(InputNr: LongInt);
  procedure ClearCounters;
  procedure ClearMotors;
  procedure CloseInterface;
  function  Finish(InputNr: LongInt=0): Boolean; overload;
  function  Finish(Code, KeyNr: LongInt): Boolean; overload;
  function  GetAnalog(AnalogNr: LongInt): LongInt;
  function  GetCounter(InputNr: LongInt): LongInt;
  function  GetInput(InputNr: LongInt): Boolean;
  function  GetInputs: LongInt;
  function  GetIRKey(Code, KeyNr: LongInt): Boolean;
  function  GetVoltage(VoltNr: LongInt): LongInt;
  procedure OpenInterface(ifTyp, SerialNr: LongInt;
                          DoEvents: Boolean=true); overload;
  procedure OpenInterface(ifTyp, ComNr, AnalogZyklen: LongInt;
                          DoEvents: Boolean=true); overload;
  procedure Pause(mSek: Cardinal);
  procedure SetCounter(InputNr, Value: LongInt);
  procedure SetLamp(LampNr, OnOff: LongInt; Power: LongInt=7);
  procedure SetMotor(MotorNr, Direction, Speed, Counter: LongInt); overload;
  procedure SetMotor(MotorNr, Direction, Speed: LongInt); overload;
  procedure SetMotor(MotorNr, Direction: LongInt); overload;
  procedure SetMotors(MotorStatus, SpeedStatus, SpeedStatus16,
                      ModeStatus: LongInt); overload;
  procedure SetMotors(MotorStatus, SpeedStatus,
                                   SpeedStatus16: LongInt); overload;
  procedure SetMotors(MotorStatus: LongInt); overload;
  procedure WaitForChange(InputNr, NrOfChanges:LongInt; TermInputNr: LongInt=0);
  procedure WaitForHigh(InputNr: LongInt);
  procedure WaitForInput(InputNr: LongInt; OnOff: Boolean=true); overload;
  procedure WaitForInput(Code, KeyNr: LongInt; OnOff: Boolean=true); overload;
  procedure WaitForLow(InputNr: LongInt);
  function  WaitForMotors(mSek: Cardinal; P1: LongInt;
                          P2: LongInt=0; P3: LongInt=0; P4: LongInt=0;
                          P5: LongInt=0; P6: LongInt=0; P7: LongInt=0;
                          P8: LongInt=0): LongInt;
  procedure WaitForPositionDown(InputNr: LongInt; var Counter: LongInt;
                                Position: LongInt;
                                TermInputNr: LongInt=0);
  procedure WaitForPositionUp(InputNr: LongInt; var Counter: LongInt;
                               Position: LongInt;
                               TermInputNr: LongInt=0);
  procedure WaitForTime(mSek: LongInt);

  constructor Create;
  destructor Destroy; override;
end;

// -------------------- TFishRobot -----------------------------------------

  TFishRobot = class(TFishFace)
  private
    PosTab: array[1..8] of PosSatz;
    FOnFishPosition: TFishPosition;
    function  GetmaxPosition(MotorNr: LongInt): LongInt;
    procedure SetmaxPosition(MotorNr, Wert: LongInt);
    procedure Starten(MotNr, zielPos: LongInt);
    function  WoIst(i, Pos: LongInt): LongInt;
    function  GetaktPosition(MotorNr: LongInt): LongInt;
    procedure SetaktPosition(MotorNr, Wert: LongInt);

  public
    property OnFishPosition: TFishPosition read  FOnFishPosition
                                           write FOnFishPosition;

    property aktPosition[MotorNr: LongInt]: LongInt read  GetaktPosition
                                                    write SetaktPosition;
    property maxPosition[MotorNr: LongInt]: LongInt read  GetmaxPosition
                                                    write SetmaxPosition;

    procedure MoveHome;
    procedure MoveTo(P1: LongInt=nullPos; P2: LongInt=nullPos;
                     P3: LongInt=nullPos; P4: LongInt=nullPos);

    constructor Create;
  end;

// --------------------- Implementation ------------------------------------

implementation

// {$R *.DFM}

const
  rbPollInterval = 10;
  rbFehler = LongInt($E0000001);

// --- umFish40.DLL Deklarationen -------------------------------------------

function rbOpenInterfaceUSB(ifTyp, SerialNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbOpenInterfaceCOM(ifTyp, ComNrNr, AnalogZyklen: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbCloseInterface(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetInput(iHandle, InputNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetInputs(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetAnalog(iHandle, AnalogNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetIRKey(iHandle, Code, KeyNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetVoltage(iHandle, VoltNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetMotor(iHandle, MotorNr, Direction: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetMotorEx(iHandle, MotorNr, Direction, Speed: LongInt):LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetMotors(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetMotors(iHandle, MotorStatus: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetMotorsEx(iHandle, MotorStatus,
                       SpeedStatus, SpeedStatus16: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetModeStatus(iHandle, MotorNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetModeStatus(iHandle, MotorNr, Mode: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetLamp(iHandle, LampNr, OnOff: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetLampEx(iHandle, LampNr, OnOff, Power: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbRobMotor(iHandle, MotorNr, Direction,
                             Speed, ICount: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbRobMotors(iHandle, MotorStatus, SpeedStatus, SpeedStatus16,
                              ModeStatus:LongInt):LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetCounter(iHandle, CounterNr: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbSetCounter(iHandle, CounterNr, ICount: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbClearCounters(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetActDeviceType(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetActDeviceSerialNr(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';
function rbGetActDeviceFirmwareNr(iHandle: LongInt): LongInt;
                                              stdcall; external 'umFish40.DLL';

// --------------------- { TFishFace } ---------------------------------

constructor TFishFace.Create();
begin
  FVersion := '4.0.01';
end;

destructor TFishFace.Destroy;
begin
  inherited Destroy;
end;

function TFishFace.GetActDevice;
var dd: DeviceData; f: LongInt;
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.ActDevice');
  dd.Typ := rbGetActDeviceType(iHandle);
  dd.SerialNr := rbGetActDeviceSerialNr(iHandle);
  f := rbGetActDeviceFirmwareNr(iHandle);
  dd.Firmware := Format('%d.%d.%d.%d',
                         [(f and $FF000000) shr 24,
                          (f and $FF0000)   shr 16,
                          (f and $FF00)     shr 8,
                          (f and $FF)]);
  case (dd.Typ) of
  10: begin;  dd.Name := 'Intelligent IF';       end;
  20: begin;  dd.Name := 'Intelligent IF Slave'; end;
  50: begin;  dd.Name := 'ROBO IF IIM';          end;
  60: begin;  dd.Name := 'ROBO IF USB';          end;
  70: begin;  dd.Name := 'ROBO IF COM';          end;
  80: begin;  dd.Name := 'ROBO IF Over RF';      end;
  90: begin;  dd.Name := 'ROBO IO Extension';    end;
  110: begin; dd.Name := 'ROBO RF Datalink';     end;
  else begin; dd.Name := 'Unknown';              end;
  end;
  Result := dd;
end;
function TFishFace.GetOutputs;
var res: LongInt;
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.Outputs');
  res := rbGetMotors(iHandle);
  if res = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.Outputs');
  Result := res;
end;

function TFishFace.GetStatus;
begin
  if rbGetInputs(iHandle) = rbFehler then Result := False
  else Result := True;
end;

procedure TFishFace.ClearCounter(InputNr: LongInt);
// --- Lschen eines Counters ---------------------------------
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.ClearCounter');
  if rbSetCounter(iHandle, InputNr, 0) = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.ClearCounter');
end;

procedure TFishFace.ClearCounters;
// --------------- Lschen aller Counter ---------------
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.ClearCounters');
  if rbClearCounters(iHandle) = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.ClearCounters');
end;

procedure TFishFace.ClearMotors;
// ------- Lschen aller M-Ausgnge -------------------------
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.ClearMotors');
  if rbSetMotors(iHandle, 0) = rbFehler then
      raise FishFaceException.Create('InterfaceProblem.ClearMotors');
end;

procedure TFishFace.CloseInterface;
// ------ Schlieen Interface ------------------------------
begin
  if FOpen then begin
   if rbCloseInterface(iHandle) = rbFehler then
       raise FishFaceException.Create('InterfaceProblem.CloseInterface');
   FOpen := false;
  end;
end;

function TFishFace.Finish(InputNr: LongInt): Boolean;
// -------- Feststellen Endewunsch (NotHalt, Escape, InputNr) -----
begin
  Result := true;
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.Finish');
  if FNotHalt or (GetAsyncKeyState(VK_Escape) <> 0) then exit;
  if GetInputs() = rbFehler then
    raise FishFaceException.Create('InterfaceProblem.Finish');
  if InputNr > 0 then if rbGetInput(iHandle, InputNr) = 1 then exit;
  Result := false;
end;

function TFishFace.Finish(Code, KeyNr: LongInt): Boolean;
// -------- Feststellen Endewunsch (NotHalt, Escape, Code/IRKey) -----
begin
  Result := true;
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.Finish');
  if FNotHalt or (GetAsyncKeyState(VK_Escape) <> 0) then exit;
  if GetInputs = rbFehler then
    raise FishFaceException.Create('InterfaceProblem.Finish');
  if rbGetIRKey(iHandle, Code, KeyNr) = 1 then exit;
  Result := false;
end;

function TFishFace.GetAnalog(AnalogNr: LongInt): LongInt;
// --------------- Auslesen Analogwert ------------------------------
var res: LongInt;
begin
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.GetAnalog');
  res := rbGetAnalog(iHandle, AnalogNr);
  if res = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.GetAnalog');
  Result := res;
end;

function TFishFace.GetCounter(InputNr: LongInt): LongInt;
// ---------- Lesen eines ImpulsCounters -------------------------------
var res: LongInt;
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.GetCounter');
  res := rbGetCounter(iHandle, InputNr);
  if res = rbFehler then
    raise FishFaceException.Create('InterfaceProblem.GetCounter');
  Result := res;
end;

function TFishFace.GetInput(InputNr: LongInt): Boolean;
// -------------- Bestimmen des Status des E-Einganges InputNr ---------
var res: LongInt;
begin
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.GetInput');
  res := rbGetInput(iHandle, InputNr);
  if res = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.GetInput');
  if res = 1 then Result := true else Result := false;
end;

function TFishFace.GetInputs: LongInt;
// -------- Auslesen des Status aller E-Eingnge -------------------------
var res: LongInt;
begin
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.GetInputs');
  res := rbGetInputs(iHandle);
  if res = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.GetInputs');
  Result := res;
end;

function TFishFace.GetIRKey(Code, KeyNr: LongInt): Boolean;
// -------------- Auslesen eines Wertes des IR-Receivers ---------
var res: LongInt;
begin
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.GetIRKey');
  res := rbGetIRKey(iHandle, Code, KeyNr);
  if res = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.GetIRKey');
  if res = 1 then Result := true else Result := false;
end;

function TFishFace.GetVoltage(VoltNr: LongInt): LongInt;
// -------------- Auslesen Spannungswert ---------
var res: LongInt;
begin
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.GetVoltage');
  res := rbGetVoltage(iHandle, VoltNr);
  if res = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.GetVoltage');
  Result := res;
end;

procedure TFishFace.OpenInterface(ifTyp, SerialNr: LongInt;
                                  DoEvents: Boolean=true);
// -------------- Verbindung zum Interface herstellen : USB ---------------
begin
  iHandle := rbOpenInterfaceUSB(ifTyp, SerialNr);
  if  iHandle = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.OpenInterface');
  FOpen     := true;
  fNotHalt  := false;
  FDoEvents := DoEvents;
  ClearMotors;
end;

procedure TFishFace.OpenInterface(ifTyp, ComNr, AnalogZyklen: LongInt;
                                  DoEvents: Boolean=true);
// -------------- Verbindung zum Interface herstellen : COM ---------------
begin
  iHandle := rbOpenInterfaceCOM(ifTyp, ComNr, AnalogZyklen);
  if  iHandle = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.OpenInterface');
  FOpen     := true;
  fNotHalt  := false;
  FDoEvents := DoEvents;
  ClearMotors;
end;

procedure TFishFace.Pause(mSek: Cardinal);
// ---------------- Programm anhalten --------------------------------------
var sZeit: Cardinal;
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.Pause');
  sZeit := GetTickCount;
  repeat
    if FDoEvents then Application.ProcessMessages;
    if rbGetInputs(iHandle) = rbFehler then
       raise FishFaceException.Create('InterfaceProblem.Pause');
    if FNotHalt or (GetAsyncKeyState(VK_Escape) <> 0) then exit;
    Sleep(rbPollInterval);
  until (GetTickCount - sZeit > mSek);
end;

procedure TFishFace.SetCounter(InputNr, Value: LongInt);
// ---------------Setzen eines ImpulsCounters -------------------------------
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.SetCounter');
  if rbSetCounter(iHandle, InputNr, Value) = rbFehler then
    raise FishFaceException.Create('InterfaceProblem.SetCounter');
end;

procedure TFishFace.SetLamp(LampNr, OnOff, Power: LongInt);
// -------------- Setzen eines 'halben' M-ausganges -------------------------
begin
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.SetLamp');
  if rbSetLampEx(iHandle, LampNr, OnOff, Power) = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.SetLamp');
end;

procedure TFishFace.SetMotor(MotorNr, Direction, Speed, Counter: LongInt);
// ------------ Setzen eines M-Ausganges, Speed, Counter -------------------
begin
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.SetMotor');
  if rbRobMotor(iHandle, MotorNr, Direction, Speed, Counter) = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.SetMotor');
end;

procedure TFishFace.SetMotor(MotorNr, Direction, Speed: LongInt);
// ---------- Setzen eines M-Ausganges, Speed ----------------------------
begin
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.SetMotor');
  if rbSetMotorEx(iHandle, MotorNr, Direction, Speed) = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.SetMotor');
end;

procedure TFishFace.SetMotor(MotorNr, Direction: LongInt);
// ----------- Setzen eines M-Ausganges -----------------------------------
begin
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.SetMotor');
  if rbSetMotor(iHandle, MotorNr, Direction) = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.SetMotor');
end;

procedure TFishFace.SetMotors(MotorStatus, SpeedStatus, SpeedStatus16,
                              ModeStatus: LongInt);
// --------------- Setzen aller M-Ausgnge, Speed, Mode -------------------
begin
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.SetMotors');
  if rbRobMotors(iHandle, MotorStatus, SpeedStatus, SpeedStatus16,
               ModeStatus) = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.SetMotors');
end;

procedure TFishFace.SetMotors(MotorStatus, SpeedStatus,
                                           SpeedStatus16: LongInt);
// ------------- Setzen aller M-Ausgnge, Speed ---------------------------
begin
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.SetMotors');
  if rbSetMotorsEx(iHandle, MotorStatus,
                            SpeedStatus, SpeedStatus16) = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.SetMotors');
end;

procedure TFishFace.SetMotors(MotorStatus: LongInt);
// ------------- Setzen aller M-Ausgnge ---------------------------------
begin
  if FDoEvents then Application.ProcessMessages;
  if not FOpen then raise FishFaceException.Create('KeinOpen.SetMotors');
  if rbSetMotors(iHandle, MotorStatus) = rbFehler then
     raise FishFaceException.Create('InterfaceProblem.SetMotors');
end;

procedure TFishFace.WaitForChange(InputNr, NrOfChanges,
                                  TermInputNr: LongInt);
// ------- Warten auf NrOfChanges Impulse von InputNr ---------------------
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.WaitForChange');
  ClearCounter(InputNr);
  while GetCounter(InputNr) < NrOfChanges do
  begin
    if FNotHalt or (GetAsyncKeyState(VK_ESCAPE) <> 0) then exit;
    if rbGetInputs(iHandle) = rbFehler then
       raise FishFaceException.Create('InterfaceProblem.WaitForChange');
    if TermInputNr > 0 then if GetInput(InputNr) then exit;
    if FDoEvents then Application.ProcessMessages;
  end;
end;

procedure TFishFace.WaitForHigh(InputNr: LongInt);
// ------- Warten auf einen False/True-Durchgang in InputNr ---------------
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.WaitForHigh');
  WaitForInput(InputNr, false);
  WaitForInput(InputNr, true);
end;

procedure TFishFace.WaitForInput(InputNr: LongInt; OnOff: Boolean);
// --------- Warten auf InputNr = OnOff -----------------------------------
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.WaitForInput');
  repeat
    if rbGetInputs(iHandle) = rbFehler then
       raise FishFaceException.Create('InterfaceProblem.WaitForInput');
    if FNotHalt or (GetAsyncKeyState(VK_ESCAPE) <> 0) then exit;
    if FDoEvents then Application.ProcessMessages;
    Sleep(rbPollInterval);
  until GetInput(InputNr) = OnOff;
end;

procedure TFishFace.WaitForInput(Code, KeyNr: LongInt; OnOff: Boolean);
// --------- Warten auf Code/KeyNr = OnOff -----------------------------------
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.WaitForInput');
  repeat
    if rbGetInputs(iHandle) = rbFehler then
       raise FishFaceException.Create('InterfaceProblem.WaitForInput');
    if FNotHalt or (GetAsyncKeyState(VK_ESCAPE) <> 0) then exit;
    if FDoEvents then Application.ProcessMessages;
    Sleep(rbPollInterval);
  until GetIRKey(Code, KeyNr) = OnOff;
end;

procedure TFishFace.WaitForLow(InputNr: LongInt);
// --------- Warten auf einen True/False-Durchgang in InputNr -------------
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.WaitForLow');
  WaitForInput(InputNr, true);
  WaitForInput(InputNr, false);
end;

function TFishFace.WaitForMotors(mSek: Cardinal; P1, P2, P3, P4: LongInt;
                                        P5, P6, P7, P8: LongInt): LongInt;
// ------------ Warten auf MotorReady-Ereignis oder Ablauf mSek ----------
var c: LongInt; t: Cardinal;
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.WaitForMotors');
  t := GetTickCount + mSek;
  repeat
    c := 0;
    if P1 > 0 then c := c + rbGetModeStatus(iHandle, P1);
    if P2 > 0 then c := c + rbGetModeStatus(iHandle, P2);
    if P3 > 0 then c := c + rbGetModeStatus(iHandle, P3);
    if P4 > 0 then c := c + rbGetModeStatus(iHandle, P4);
    if P5 > 0 then c := c + rbGetModeStatus(iHandle, P5);
    if P6 > 0 then c := c + rbGetModeStatus(iHandle, P6);
    if P7 > 0 then c := c + rbGetModeStatus(iHandle, P7);
    if P8 > 0 then c := c + rbGetModeStatus(iHandle, P8);

    Result := ftiEnde;
    If c = 0 then exit;

    // --- Abschalten der Motoren der Parameterliste ---
    if FNotHalt or (GetAsyncKeyState(VK_ESCAPE) <> 0) then
    begin
      if P1 > 0 then rbSetMotor(iHandle, P1, 0);
      if P2 > 0 then rbSetMotor(iHandle, P2, 0);
      if P3 > 0 then rbSetMotor(iHandle, P3, 0);
      if P4 > 0 then rbSetMotor(iHandle, P4, 0);
      if P5 > 0 then rbSetMotor(iHandle, P5, 0);
      if P6 > 0 then rbSetMotor(iHandle, P6, 0);
      if P7 > 0 then rbSetMotor(iHandle, P7, 0);
      if P8 > 0 then rbSetMotor(iHandle, P8, 0);
    end;

    Result := ftiNotHalt;
    if FNotHalt then exit;
    Result := ftiEsc;
    if GetAsyncKeyState(VK_ESCAPE) <> 0 then exit;

   if FDoEvents then Application.ProcessMessages;
   if rbGetInputs(iHandle) = rbFehler then
       raise FishFaceException.Create('InterfaceProblem.WaitForMotors');

  until ((t < GetTickCount) and (mSek > 0));
  Result := ftiTime;
end;

procedure TFishFace.WaitForPositionDown(InputNr: LongInt;
                       var Counter: LongInt; Position, TermInputNr: LongInt);
// -------- Warten Position = Counter - InputNr-Impulse ---------------------
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.WaitForPositionDown');
  WaitForChange(InputNr, Counter-Position, TermInputNr);
  Counter := Counter - GetCounter(InputNr);
end;

procedure TFishFace.WaitForPositionUp(InputNr: LongInt;
                        var Counter: LongInt; Position, TermInputNr: LongInt);
// ------ Warten Position = Counter + InputNr-Impulse ------------------------
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.WaitForPositionUp');
  WaitForChange(InputNr, Position-Counter, TermInputNr);
  Counter := Counter + GetCounter(InputNr);
end;

procedure TFishFace.WaitForTime(mSek: LongInt);
// -------- Programm anhalten -----------------------------------------------
begin
  if not FOpen then raise FishFaceException.Create('KeinOpen.WaitForTime');
  Pause(mSek);
end;

// -------- TFishRobot ----------------------------------------------------

function TFishRobot.GetaktPosition(MotorNr: LongInt): LongInt;
begin
  Result := PosTab[MotorNr].aktPosition;
end;

procedure TFishRobot.SetaktPosition(MotorNr, Wert: LongInt);
begin
  PosTab[MotorNr].aktPosition := Wert;
end;

function TFishRobot.GetmaxPosition(MotorNr: LongInt): LongInt;
begin
  Result := PosTab[MotorNr].maxPosition;
end;

procedure TFishRobot.SetmaxPosition(MotorNr, Wert: LongInt);
begin
  PosTab[MotorNr].maxPosition := Wert;
end;

constructor TFishRobot.Create;
begin
  inherited Create;
  PosTab[1].maxPosition := 180;
  PosTab[2].maxPosition := 100;
  PosTab[3].maxPosition := 80;
  PosTab[4].maxPosition := 24;
end;

procedure TFishRobot.MoveHome;
// --- Anfahren der Home-Position ----------------------
var i: LongInt;
begin
  for i := 1 to 4 do begin
    PosTab[i].aktPosition := 0;
    SetMotor(i, ftiLeft, ftiFull, nullPos);
    end;
    WaitForMotors(0, ftiM1, ftiM2, ftiM3, ftiM4);
end;

procedure TFishRobot.MoveTo(P1, P2, P3, P4: LongInt);
// --- Simultanes Anfahren einer vorgegebenen Position -----------
begin
// --- Starten aller Motoren, wenn nicht nullPos ---
  Starten(ftiM1, P1);
  Starten(ftiM2, P2);
  Starten(ftiM3, P3);
  Starten(ftiM4, P4);

// --- Warten auf Ready aller Motoren und laufende Positionsangabe ---
  while WaitForMotors(80, ftiM1, ftiM2, ftiM3, ftiM4) = ftiTime do
    if Assigned(FOnFishPosition) then FOnFishPosition(Self,
        WoIst(ftiM1, P1), WoIst(ftiM2, P2), WoIst(ftiM3, P3), WoIst(ftiM4, P4));

// --- Aktualisieren PosTab ------------------------------------------
  if P1 <> nullPos then if P1 > PosTab[1].aktPosition
                        then PosTab[1].aktPosition := P1 - GetCounter(2)
                        else PosTab[1].aktPosition := P1 + GetCounter(2);
  if P2 <> nullPos then if P2 > PosTab[2].aktPosition
                        then PosTab[2].aktPosition := P2 - GetCounter(4)
                        else PosTab[2].aktPosition := P2 + GetCounter(4);
  if P3 <> nullPos then if P3 > PosTab[3].aktPosition
                        then PosTab[3].aktPosition := P3 - GetCounter(6)
                        else PosTab[3].aktPosition := P3 + GetCounter(6);
  if P4 <> nullPos then if P4 > PosTab[4].aktPosition
                        then PosTab[4].aktPosition := P4 - GetCounter(8)
                        else PosTab[4].aktPosition := P4 + GetCounter(8);

// --- Abschlieende Positionsangabe ------------------------------------
  if Assigned(FOnFishPosition) then FOnFishPosition(Self,
                                                    PosTab[1].aktPosition,
                                                    PosTab[2].aktPosition,
                                                    PosTab[3].aktPosition,
                                                    PosTab[4].aktPosition); 
end;

procedure TFishRobot.Starten(MotNr, zielPos: Integer);
// --- Starten eines Motors im RobMode, wenn zielPos <> nullPos ---
var ct: LongInt;
begin
  if zielPos <> nullPos then begin
    if zielPos > PosTab[MotNr].maxPosition then
                                          zielPos := PosTab[MotNr].maxPosition;
    if zielPos > PosTab[MotNr].aktPosition then
      SetMotor(MotNr, ftiRechts, ftiFull, zielPos-PosTab[MotNr].aktPosition)
    else begin
      ct := PosTab[MotNr].aktPosition - zielPos;
      if ct > 0 then SetMotor(MotNr, ftiLinks, ftiFull, ct);
      end;
  end;
end;

function TFishRobot.WoIst(i, Pos: Integer): LongInt;
// --- Bestimmen der aktuellen Position --------------------------
var j: LongInt;
begin
  j := (i-1) * 2 + 2;
  if Pos = nullPos then Result := PosTab[i].aktPosition
  else if Pos > PosTab[i].aktPosition then Result := Pos - GetCounter(j)
                                      else Result := Pos + GetCounter(j);
end;

end.
