// ----------------------------------------------------------------------------
//
// ftMain.PAS/DFM                                        Ulrich Mller 21.11.05
//                                                       PCS1700     Delphi4.03
// ftTeach : HauptForm
//
// ----------------------------------------------------------------------------

unit ftMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ExtCtrls, IniFiles, FishFace40;

type
  TPrgModus = (mdNone, mdEin, mdHome, mdTeachIn, mdRun);
  TfrmMain = class(TForm)
    cmdAction: TButton;
    cmdEnde: TButton;
    lblPrgModus: TLabel;
    pnlFahren: TPanel;
    memDaten: TMemo;
    lblTitel: TLabel;
    pnlPosition: TPanel;
    pnlRun: TPanel;
    cmdScriptStarten: TButton;
    chkWiederholen: TCheckBox;
    cmdZuruck: TButton;
    cmdVor: TButton;
    cmdAufPosition: TButton;
    cmdPosSpeichern: TButton;
    cmdPosEinfugen: TButton;
    cmdPosAnfugen: TButton;
    cmdPosLoschen: TButton;
    shpInterface: TShape;
    tmrI: TTimer;
    shpSaule: TShape;
    shpArmV: TShape;
    shpArmH: TShape;
    shpZusatz: TShape;
    lblM4Zu: TLabel;
    lblM4Auf: TLabel;
    sphM2R: TShape;
    shpM2L: TShape;
    shpM3L: TShape;
    shpM3R: TShape;
    shpM1L: TShape;
    shpM1R: TShape;
    lblM2Pos: TLabel;
    lblM3Pos: TLabel;
    lblM1Pos: TLabel;
    dlgOpen: TOpenDialog;
    dlgSave: TSaveDialog;
    lstScript: TListBox;
    MainMenu1: TMainMenu;
    mnuDatei: TMenuItem;
    mnuNeu: TMenuItem;
    mnuOffnen: TMenuItem;
    mnuSpeichern: TMenuItem;
    mnuSpeichernU: TMenuItem;
    N1: TMenuItem;
    mnuEnde: TMenuItem;
    mnuOPtionen: TMenuItem;
    mnuSchnitt: TMenuItem;
    mnuModell: TMenuItem;
    mnuHilfe: TMenuItem;
    procedure cmdActionClick(Sender: TObject);
    procedure cmdEndeClick(Sender: TObject);
    procedure cmdScriptStartenClick(Sender: TObject);
    procedure cmdPosAnfugenClick(Sender: TObject);
    procedure cmdPosSpeichernClick(Sender: TObject);
    procedure cmdPosEinfugenClick(Sender: TObject);
    procedure cmdPosLoschenClick(Sender: TObject);
    procedure cmdZuPositionClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure lblM4Click(Sender: TObject);
    procedure mnuEndeClick(Sender: TObject);
    procedure mnuOffnenClick(Sender: TObject);
    procedure mnuNeuClick(Sender: TObject);
    procedure mnuSpeichernUClick(Sender: TObject);
    procedure mnuSpeichernClick(Sender: TObject);
    procedure shpMotMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure shpMotMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure tmrITimer(Sender: TObject);
    procedure mnuModellClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure mnuSchnittClick(Sender: TObject);
  private
    procedure Beenden;
    procedure HomeRun;
    procedure IniLesen;
    procedure IniSchreiben;
    procedure ModellDaten;
    procedure ModusWechsel(NewMode: TPrgModus);
    function  MotToScript:string ;
    procedure ScriptToMove;
    procedure Zusatz(OnOff: Cardinal);
    procedure OnFishPosition(Sender: TFishRobot;
                             Pos1, Pos2, Pos3, Pos4: LongInt);
  public
    { Public-Deklarationen }
  end;
  lowI = set of 0..8;

const
  clHellGrau = $E0E0E0; rtGreifer = 'G'; rtZusatz = 'Z';
var
  frmMain: TfrmMain;
  ft: TFishRobot;
  PrgModus: TPrgModus; INI: TIniFile; Pfad, DateiName: string;
  ifTyp, ifNr: LongInt; ifName, ifPort: string;
  RobTyp, RobModell, RobExt, RobBez: string;
  COMTypen: lowI;


implementation

uses ftModell, ftAbout, ftSchnit;

{$R *.DFM}

var
  MoveWerte: array[1..4] of Integer; IsDirty: Boolean;


procedure TfrmMain.Beenden;
// --- Beenden des gesamten Programmes ----------------------
begin
  tmrI.Enabled := false;
  IniSchreiben;
  if IsDirty then if MessageDlg('Script-Datei Speichern?',
                       mtInformation, [mbYes, mbNo], 0) = mrYes then
                          mnuSpeichernUClick(Self);
  Sleep(12);
  ft.CloseInterface;
  ft.Free;
  INI.Free;
end;


procedure TfrmMain.HomeRun;
// -------------------- Anfahren der Home-Position -----------------------
var i: cardinal;
begin
  ft.NotHalt := false;
  ft.MoveHome;
  ft.ClearMotors;
  for i := 1 to 4 do MoveWerte[i] := 0;
end;


procedure TfrmMain.IniLesen;
// --- Einlesen der ftTeach.INI-Daten ----------------------
begin
  Self.Left := INI.ReadInteger('Common',    'Left',     50);
  Self.Top  := INI.ReadInteger('Common',    'Top',      50);
  RobModell := INI.ReadString('Common',     'RobModel', 'Rob3');
  ifName    := INI.ReadString('Interface',  'Name',     'ROBO first USB');
  ifPort    := INI.ReadString('Interface',  'Port',     'USB');
  ifTyp     := INI.ReadInteger('Interface', 'Typ',      0);
  ifNr      := INI.ReadInteger('Interface', 'Nr',       0);
  RobTyp    := INI.ReadString(RobModell,    'RobType',  rtGreifer);
  RobBez    := INI.ReadString(RobModell,    'RobText',  'Sulenroboter');
  RobExt    := 'RB' + RobModell[Length(RobModell)];
  ft.maxPosition[1] := INI.ReadInteger(RobModell, 'Sule',   240);
  ft.maxPosition[2] := INI.ReadInteger(RobModell, 'ArmH',    160);
  ft.maxPosition[3] := INI.ReadInteger(RobModell, 'ArmV',    150);
  if RobTyp = rtGreifer then
  ft.maxPosition[4] := INI.ReadInteger(RobModell, 'Greifer', 28);
end;


procedure TfrmMain.IniSchreiben;
// --- Schreiben der ftTeach.INI-Daten ----------------------
begin
  INI := TIniFile.Create(Pfad + 'ftTeach.INI');
  INI.WriteInteger('Common',    'Left',     Self.Left);
  INI.WriteInteger('Common',    'Top',      Self.Top);
  INI.WriteString('Common',     'RobModel', RobModell);
  INI.WriteString('Interface',  'Name',     ifName);
  INI.WriteString('Interface',  'Port',     ifPort);
  INI.WriteInteger('Interface', 'Typ',      ifTyp);
  INI.WriteInteger('Interface', 'Nr',       ifNr);
  INI.WriteString(RobModell,    'RobType',  RobTyp);
  INI.WriteString(RobModell,    'RobText',  RobBez);
  INI.WriteInteger(RobModell,   'Sule',    ft.maxPosition[1]);
  INI.WriteInteger(RobModell,   'ArmH',     ft.maxPosition[2]);
  INI.WriteInteger(RobModell,   'ArmV',     ft.maxPosition[3]);
  if RobTyp = rtGreifer then
  INI.WriteInteger(RobModell,   'Greifer',  ft.maxPosition[4]);
end;


procedure TfrmMain.ModellDaten;
// --- Listen der Modelldaten ---------------------------------------------
begin
  lblTitel.Caption := RobModell + ' : ' + robBez;
  memDaten.Clear;
  memDaten.Lines.Add('Modell : ' + RobModell);
  memDaten.Lines.Add('Arbeitsraum');
  memDaten.Lines.Add('Sule : ' + IntToStr(ft.maxPosition[1]));
  memDaten.Lines.Add('ArmH : '  + IntToStr(ft.maxPosition[2]));
  memDaten.Lines.Add('ArmV : '  + IntToStr(ft.maxPosition[3]));
  if RobTyp = rtGreifer then
    memDaten.Lines.Add('Greifer : ' + IntToStr(ft.maxPosition[4]));
  memDaten.Lines.Add('Interface : ');
  memDaten.Lines.Add(ifName);
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
// --- bedingtes Beenden des Programms -----------------------------------
begin
  if PrgModus = mdRun then begin Action := caNone; exit; end;
  Beenden;
end;


procedure TfrmMain.FormCreate(Sender: TObject);
begin
  Self.Caption := Application.Title;
  PrgModus     := mdNone;
  ft           := TFishRobot.Create;
  Pfad         := ExtractFilePath(Application.ExeName);
  SetCurrentDir(ExtractFileDir(Application.ExeName));
  INI          := TIniFile.Create(Pfad + 'ftTeach.INI');
  IniLesen;
  ModellDaten;
  mnuNeuClick(Self);
  ModusWechsel(mdEin);
end;


procedure TfrmMain.ModusWechsel(NewMode: TPrgModus);
// --- Schalten in den gewnschten Betriebsmodus --------------------
//     Setzen/Lschen Sperren, Beschriften, ProModus : ... ----------
begin
  case NewMode of
  mdEin: begin              // --- nach Programmstart, nicht wiederholbar ---
    lblPrgModus.Caption  := 'EINschalten';
    cmdAction.Caption    := 'EIN';
    cmdAction.Enabled    := true;
    cmdEnde.Caption      := 'Abbrechen';
    cmdEnde.Enabled      := true;
    pnlFahren.Color      := clBtnFace;
    pnlFahren.Enabled    := false;
    pnlPosition.Enabled  := false;
    pnlPosition.Color    := clBtnFace;
    pnlRun.Enabled       := false;
    pnlRun.Color         := clBtnFace;
    mnuDatei.Enabled     := true;
    mnuOptionen.Enabled  := true;
    mnuHilfe.Enabled     := true;
    PrgModus             := mdEin;
    end;
  mdHome: begin             // --- nach OpenInterface, nicht wiederholbar ---
    lblPrgModus.Caption  := 'Home anfahren';
    cmdAction.Caption    := 'STARTEN';
    cmdAction.Enabled    := true;
    cmdEnde.Caption      := 'ENDE';
    cmdEnde.Enabled      := true;
    pnlFahren.Color      := clBtnFace;
    pnlFahren.Enabled    := false;
    pnlPosition.Enabled  := false;
    pnlPosition.Color    := clBtnFace;
    pnlRun.Enabled       := true;
    pnlRun.Color         := clBtnFace;
    mnuDatei.Enabled     := true;
    mnuOptionen.Visible  := false;
    mnuHilfe.Enabled     := true;
    PrgModus             := mdHome;
    end;
  mdTeachIn: begin          // --- nach erfolgreichem Home : Normal-Status
                            //     stellt sich nach Fahren wieder ein
    lblPrgModus.Caption  := 'TeachIn';
    cmdAction.Caption    := 'HOME';
    cmdAction.Enabled    := true;
    cmdEnde.Caption      := 'ENDE';
    cmdEnde.Enabled      := true;
    pnlFahren.Color      := clHellGrau;
    pnlFahren.Enabled    := true;
    pnlPosition.Enabled  := true;
    pnlPosition.Color    := clHellGrau;
    pnlRun.Enabled       := true;
    pnlRun.Color         := clHellGrau;
    mnuDatei.Enabled     := true;
    mnuOptionen.Visible  := false;
    mnuHilfe.Enabled     := true;
    PrgModus             := mdTeachIn;
    end;
  mdRun: begin              // --- whrend einer Robot-Fahrt : ScriptStarten,
                            //     Fahren, Home
    lblPrgModus.Caption  := 'RUN';
    cmdAction.Caption    := 'HALT';
    cmdAction.Enabled    := true;
    cmdEnde.Caption      := 'ENDE';
    cmdEnde.Enabled      := false;
    pnlFahren.Color      := clBtnFace;
    pnlFahren.Enabled    := false;
    pnlPosition.Enabled  := false;
    pnlPosition.Color    := clBtnFace;
    pnlRun.Enabled       := false;
    pnlRun.Color         := clBtnFace;
    mnuDatei.Enabled     := false;
    mnuOptionen.Visible  := false;
    mnuHilfe.Enabled     := false;
    PrgModus             := mdRun;
    end;
  end;
end;


function TfrmMain.MotToScript: string;
// --- Aufbereiten der aktuellen MotCntl.Position zu einer Scriptzeile ---
var Zeile: string;
begin
  Zeile  :=         Format('%6d', [ft.aktPosition[1]]);
  Zeile  := Zeile + Format('%6d', [ft.aktPosition[2]]);
  Zeile  := Zeile + Format('%6d', [ft.aktPosition[3]]);
  Zeile  := Zeile + Format('%6d', [MoveWerte[4]]);
  Result := Zeile;
end;


procedure TfrmMain.ScriptToMove;
// --- Aufbereiten einer Scriptzeile zu MoveWerten -----------------------
var Zeile: string;
begin
  Zeile        := lstScript.Items[lstScript.ItemIndex];
  MoveWerte[1] := StrToInt(Copy(Zeile, 1,6));
  MoveWerte[2] := StrToInt(Copy(Zeile, 7,6));
  MoveWerte[3] := StrToInt(Copy(Zeile,13,6));
  MoveWerte[4] := StrToInt(Copy(Zeile,19,6));
end;

procedure TfrmMain.Zusatz(OnOff: Cardinal);
// --- ffnen/Schlieen Zusatzgerat --------------------------------------
begin
  MoveWerte[4] := OnOff;
  if RobTyp = rtGreifer then begin
     if OnOff = 1 then ft.MoveTo(nullPos, nullPos, nullPos, 0)
     else ft.MoveTo(nullPos, nullPos, nullPos, ft.maxPosition[4]);
    end
  else begin
    ft.SetMotor(4, OnOff);
    ft.Pause(500);
    end;
end;


procedure TfrmMain.cmdEndeClick(Sender: TObject);
// --------------- Beenden des Programms --------------------------------
begin
  Self.Close;
end;


procedure TfrmMain.cmdActionClick(Sender: TObject);
// --- Haupt-Aktionen -----------------------------------------------------
begin
  COMTypen := [10, 20, 50, 70];
  if cmdAction.Caption = 'EIN' then begin    // --- Einschalten Interface
    try
      if ifTyp in COMTypen then ft.OpenInterface(ifTyp, ifNr, 999, True)
      else ft.OpenInterface(ifTyp, ifNr, True);
    except
      on e: FishFaceException do begin
        MessageDlg('Inpterfaceproblem mit : ' + ifName, mtError, [mbOK], 0);
        cmdAction.SetFocus;
        Self.Close;
        end;
    end;
    memDaten.Lines.Add('Typ : ' + IntToStr(ft.ActDevice.Typ));
    memDaten.Lines.Add('Version ' + ft.ActDevice.Firmware);
    ft.OnFishPosition := OnFishPosition;
    tmrI.Enabled := true;
    ModusWechsel(mdHome);
    end
  else                                      // --- NotHalt
   if cmdAction.Caption = 'HALT' then begin
    ft.NotHalt := true;
    chkWiederholen.Checked := false;
    ModusWechsel(mdTeachIn);
    end
  else begin                               // --- Anfahren HOME
    ModusWechsel(mdRun);
    HomeRun;
    ModusWechsel(mdTeachIn);
    end;
end;

procedure TfrmMain.cmdScriptStartenClick(Sender: TObject);
// --- Fahren nach Daten des aktuellen Scripts -----------------------------
begin
  ModusWechsel(mdRun);
  repeat
    lstScript.ItemIndex := -1;
    ft.NotHalt := false;
    repeat
      lstScript.ItemIndex := lstScript.ItemIndex + 1;
      ScriptToMove;
      ft.MoveTo(MoveWerte[1], MoveWerte[2], MoveWerte[3]);
      Zusatz(MoveWerte[4]);
    until (lstScript.ItemIndex = (lstScript.Items.Count - 1)) Or ft.NotHalt;
  until NOT chkWiederholen.Checked;
  ModusWechsel(mdTeachIn);
end;


procedure TfrmMain.cmdZuPositionClick(Sender: TObject);
// --- Auf die im Script markierte Position fahren ----------------------
begin
  case TButton(Sender).Tag of
  1: if lstScript.ItemIndex > 0 then
        lstScript.ItemIndex := lstScript.ItemIndex - 1;
  2: lstScript.ItemIndex := lstScript.ItemIndex + 1;
  3:;
  end;
  ModusWechsel(mdRun);
  ScriptToMove;
  ft.NotHalt := false;
  ft.MoveTo(MoveWerte[1], MoveWerte[2], MoveWerte[3]);
  Zusatz(MoveWerte[4]);
  ModusWechsel(mdTeachIn);
end;


procedure TfrmMain.cmdPosAnfugenClick(Sender: TObject);
// ------------ Anfgen einer neuen Position an das Script ----------------
begin
  lstScript.Items.Add(MotToScript);
  lstScript.ItemIndex := lstScript.Items.Count - 1;
  IsDirty := true;
end;

procedure TfrmMain.cmdPosSpeichernClick(Sender: TObject);
// ---- Speichern der aktuellen Position in die markierte Zeile ----------
begin
  if lstScript.Items.Count < 1 then exit;
  lstScript.Items[lstScript.ItemIndex] := MotToScript;
  IsDirty := true;
end;

procedure TfrmMain.cmdPosEinfugenClick(Sender: TObject);
// ---- Einfgen der aktuellen Position fr die markierte Zeile ----------
begin
  if lstScript.ItemIndex = -1 then exit;
  lstScript.Items.Insert(lstScript.ItemIndex,MotToScript);
  lstScript.ItemIndex := lstScript.ItemIndex - 1;
  IsDirty := true;
end;

procedure TfrmMain.cmdPosLoschenClick(Sender: TObject);
// --- Lschen der markierten Zeile -------------------------------------
var i: Cardinal;
begin
  if lstScript.Items.Count = 1 then exit;
  i := lstScript.ItemIndex;
  lstScript.Items.Delete(i);
  if i>0 then lstScript.ItemIndex := i - 1 else lstScript.ItemIndex := 0;
  IsDirty := true;
end;


procedure TfrmMain.shpMotMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// --- TeachIn : freies Fahren ------------------------------------------
var Index: Cardinal;
begin
  Index := TShape(Sender).Tag;
  ft.NotHalt := false;

  case Index of
  1: ft.MoveTo(0);
  2: ft.MoveTo(ft.maxPosition[1]);
  3: ft.MoveTo(nullPos, 0);
  4: ft.MoveTo(nullPos, ft.maxPosition[2]);
  5: ft.MoveTo(nullPos, nullPos, 0);
  6: ft.MoveTo(nullPos, nullPos, ft.maxPosition[3]);
  end;

end;


procedure TfrmMain.shpMotMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
// --- TeachIn : Beenden freies Fahren --------------------------------
begin
  ft.NotHalt := true;
end;

procedure TfrmMain.lblM4Click(Sender: TObject);
// --- ffnen/Schlieen des Zusatzgertes ----------------------------------
begin
  ModusWechsel(mdRun);
  ft.NotHalt := false;
  Zusatz(TLabel(Sender).Tag);
  ModusWechsel(mdTeachIn);
end;


procedure TfrmMain.tmrITimer(Sender: TObject);
// --- berwachen des Interfaces ------------------------------------------
begin
  if ft.Status = False then begin
    shpInterface.Brush.Color := clRed;
    lblPrgModus.Caption := 'Interface defekt';
    cmdAction.SetFocus;
    end
  else begin
    shpInterface.Brush.Color := clLime;
  end;
 end;

procedure TfrmMain.OnFishPosition(Sender: TFishRobot;
                                  Pos1, Pos2, Pos3, Pos4: LongInt);
var EW: LongWord;
begin
  EW := ft.Outputs;
  lblM1Pos.Caption := IntToStr(Pos1);
  if (EW AND $3) > 0 then shpSaule.Brush.Color := clLime
  else shpSaule.Brush.Color := clWhite;
  lblM2Pos.Caption := IntToStr(Pos2);
  if (EW AND $C) > 0 then shpArmH.Brush.Color := clLime
  else shpArmH.Brush.Color := clWhite;
  lblM3Pos.Caption := IntToStr(Pos3);
  if (EW AND $30) > 0 then shpArmV.Brush.Color := clLime
  else shpArmV.Brush.Color := clWhite;
  if (EW AND $C0) > 0 then shpZusatz.Brush.Color := clLime
  else shpZusatz.Brush.Color := clWhite;
end;

procedure TfrmMain.mnuEndeClick(Sender: TObject);
// --- Gesamtprogramm beenden ---------------------------
begin
 Self.Close;
end;


procedure TfrmMain.mnuOffnenClick(Sender: TObject);
// --- Script einlesen -------------------------------
begin
  dlgOpen.Filter := 'Rob Script|*.' + RobExt;
  dlgOpen.DefaultExt := RobExt;
  dlgOpen.InitialDir := Pfad;
  if NOT dlgOpen.Execute then exit;
  DateiName := ExtractFilename(dlgOpen.Filename);
  lstScript.Items.LoadFromFile(dlgOpen.FileName);
  IsDirty := false;
  Self.Caption := Application.Title + ' [' + DateiName + ']';
  lstScript.ItemIndex := 0;
end;


procedure TfrmMain.mnuNeuClick(Sender: TObject);
// --- neues Script anlegen --------------------
var i: Cardinal;
begin
  lstScript.Clear;
  Self.Caption := Application.Title + ' [Neu]';
  DateiName := '';
  for i := 1 to 4 do MoveWerte[i] := 0;
  lstScript.Items.Add('     0     0     0     0');
  lstScript.ItemIndex := 0;
  IsDirty := false;
end;


procedure TfrmMain.mnuSpeichernUClick(Sender: TObject);
// --- Script unter whlbaren Namen speichern ---------
begin
  dlgSave.Filter := 'Rob Script|*.' + RobExt;
  dlgSave.DefaultExt := RobExt;
  dlgSave.InitialDir := Pfad;
  if NOT dlgSave.Execute then exit;
  lstScript.Items.SaveToFile(dlgSave.Filename);
  DateiName := ExtractFilename(dlgSave.Filename);
  Self.Caption := Application.Title + ' [' + Dateiname + ']';
  IsDirty := false;
end;


procedure TfrmMain.mnuSpeichernClick(Sender: TObject);
// ------------- Script speichern ----------------------
begin
  if DateiName = '' then mnuSpeichernUClick(Self)
  else lstScript.Items.SaveToFile(Pfad + DateiName);
  IsDirty := false;
end;

procedure TfrmMain.mnuModellClick(Sender: TObject);
// --------- Modellauswahl, Modellparameter ------------------------------
begin
  frmModell.Left := Self.Left + Self.Width  - frmModell.Width  - 20;
  frmModell.Top  := Self.Top  + Self.Height - frmModell.Height - 16;
  frmModell.ShowModal;
  Modelldaten;
end;

procedure TfrmMain.mnuAboutClick(Sender: TObject);
// --- Anzeige der AboutBox ----------------------------------------------
begin
  frmAbout.Left := Self.Left + Self.Width  - frmAbout.Width  - 32;
  frmAbout.Top  := Self.Top  + Self.Height - frmAbout.Height - 20;
  frmAbout.ShowModal;
end;

procedure TfrmMain.mnuSchnittClick(Sender: TObject);
// ---- Auswahl der Schnittstelle ---------------------------------------
begin
  frmSchnitt.Left := Self.Left + Self.Width  - frmSchnitt.Width  - 20;
  frmSchnitt.Top  := Self.Top  + Self.Height - frmSchnitt.Height - 16;
  frmSchnitt.ShowModal;
  ModellDaten;
end;



end.




