// ----------------------------------------------------------------------------
//
// ftModell.PAS/DFM                                      Ulrich Mller 21.11.05
//                                                       PCS1700     Delphi4.03
// ftTeach : Modelldaten
//
// FormCreate bernimmt die aktuellen Werte Hauptform und zeigt sie an
// Bei Auswahl eines RobModells (cboRobClick) werden dessen Daten,
// sofern vorhanden, aus ftTeach.INI gelesen, sonst einer Tabelle entnommen
// (ReadModellWerte)
// Beim Verlassen der Form ber cmdOKCLick werden die eingestellen Werte
// zu den aktuellen der Hauptform.
//
// ----------------------------------------------------------------------------

unit ftModell;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmModell = class(TForm)
    lblTitel: TLabel;
    cmdOK: TButton;
    cmdEnde: TButton;
    cboRob: TComboBox;
    cboZusatz: TComboBox;
    txtBeschreibung: TEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lblGreifer: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    txtSaule: TEdit;
    txtArmV: TEdit;
    txtArmH: TEdit;
    txtGreifer: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    procedure cmdEndeClick(Sender: TObject);
    procedure cmdOKClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cboRobClick(Sender: TObject);
    procedure cboZusatzClick(Sender: TObject);
  private
    procedure ReadModellWerte(RobModell: string);
  public
    { Public-Deklarationen }
  end;

var
  frmModell: TfrmModell;

implementation

{$R *.DFM}

uses ftMain;

procedure TfrmModell.ReadModellWerte(RobModell: string);
// --- Einlesen Modellwerte aus INI-File, wenn vorhanden ------------------
var RT: string;
begin
  if INI.SectionExists(RobModell) then begin
    RT                   := INI.ReadString(RobModell, 'RobType', 'G');
    txtBeschreibung.Text := INI.ReadString(RobModell, 'RobText', 'XXX');
    txtSaule.Text        := INI.Readstring(RobModell, 'Sule', '9999');
    txtArmH.Text         := INI.ReadString(RobModell, 'ArmH', '9999');
    txtArmV.Text         := INI.ReadString(RobModell, 'ArmV', '9999');
    if RT = rtGreifer then begin
      txtGreifer.Text := INI.ReadString(RobModell, 'Greifer', '9999');
      cboZusatz.ItemIndex := 0;
      lblGreifer.Enabled  := true;
      txtGreifer.Enabled  := true;
      end
    else begin
      cboZusatz.ItemIndex := 1;
      lblGreifer.Enabled  := false;
      txtGreifer.Enabled  := false;
      end;
    end
  else begin
    if RobModell = 'Rob2' then begin

      txtBeschreibung.Text := 'Schwei-Roboter';
      txtSaule.Text        := '210';
      txtArmH.Text         := '160';
      txtArmV.Text         := '80';
      txtGreifer.Text      := '9999';
      cboZusatz.ItemIndex  := 1;
      lblGreifer.Enabled   := false;
      txtGreifer.Enabled   := false;
      end
    else if RobModell = 'Rob4' then begin
      txtBeschreibung.Text := 'Knickarm-Roboter';
      txtSaule.Text        := '240';
      txtArmH.Text         := '160';
      txtArmV.Text         := '112';
      txtGreifer.Text      := '28';
      cboZusatz.ItemIndex  := 0;
      lblGreifer.Enabled   := true;
      txtGreifer.Enabled   := true;
      end;
    end;
end;


procedure TfrmModell.cmdEndeClick(Sender: TObject);
// --- Abbruch-Return, keine Wertbergabe --------------------------------
begin
  Self.Close;
end;

procedure TfrmModell.cmdOKClick(Sender: TObject);
// --- Return mit bernahme der eingestellten Werte ----------------------
begin
  RobModell := cboRob.Items[cboRob.ItemIndex];
  RobExt    := 'RB' + RobModell[Length(RobModell)];
  if cboZusatz.ItemIndex = 0 then RobTyp := rtGreifer else RobTyp := rtZusatz;
  RobBez    := txtBeschreibung.Text;
try
  ft.maxPosition[1] := StrToInt(txtSaule.Text);
  ft.maxPosition[3] := StrToInt(txtArmV.Text);
  ft.maxPosition[2] := StrToInt(txtArmH.Text);
  ft.maxPosition[4] := StrToInt(txtGreifer.Text);
except
  MessageDlg('Fehlerhafte Werte fr den Arbeitsraum', mtError, [mbOK], 0);
  exit;
end;
  Self.Close;
end;

procedure TfrmModell.FormCreate(Sender: TObject);
begin
// --- Aktuelle Werte -----------------------------------------------------
  cboRob.ItemIndex := StrToInt(Copy(RobModell, Length(RobModell), 1)) - 1;
  if RobTyp = rtGreifer then cboZusatz.ItemIndex := 0
  else cboZusatz.ItemIndex := 1;
  txtBeschreibung.Text := RobBez;
  txtSaule.Text        := IntToStr(ft.maxPosition[1]);
  txtArmV.Text         := IntToStr(ft.maxPosition[3]);
  txtArmH.Text         := IntToStr(ft.maxPosition[2]);
  if RobTyp = rtGreifer then begin
    txtGreifer.Text := IntToStr(ft.maxPosition[4]);
    lblGreifer.Enabled := true;
    txtGreifer.Enabled := true;
    end
  else begin
    txtGreifer.Text := '9999';
    lblGreifer.Enabled := false;
    txtGreifer.Enabled := false;
    end;
end;

procedure TfrmModell.cboRobClick(Sender: TObject);
// --- Einstellen RobModell, wenn vorhanden, Lesen der Werte aus INI -----
begin
  ReadModellWerte(cboRob.Items[cboRob.ItemIndex]);
end;


procedure TfrmModell.cboZusatzClick(Sender: TObject);
// --- Einstellen RobTyp, Enable der Felder ------------------------------
begin
  txtGreifer.Text := '9999';
  if cboZusatz.ItemIndex = 0 then begin
    lblGreifer.Enabled  := true;
    txtGreifer.Enabled  := true;
    end
  else begin
    lblGreifer.Enabled := false;
    txtGreifer.Enabled := false;
    end;
end;

end.
